/*
 * This file has been changed by Tommi Junttila by adding new
 * SYMMINTEGRATION options 6--8
 */

// System dependent sizes and values

#ifndef DIMENSIONS_H
#define DIMENSIONS_H

#include"userconfig.H"

// defaults for user defined values

#ifndef REPORTFREQUENCY
#define REPORTFREQUENCY 100
#endif

#ifndef MAXPATH
#define MAXPATH 3000000
#endif

#ifdef BREADTH_FIRST
#define GRAPH breadth_first
#undef RELAXED
#else
#define DEPTH_FIRST
#define GRAPH depth_first
#endif

#if !defined(REACHABILITY) && !defined(MODELCHECKING)&& !defined(BOUNDEDPLACE) && !defined(DEADTRANSITION) && !defined(REVERSIBILITY) && !defined(HOME) && !defined(FINDPATH) && !defined(FULL) && !defined(BOUNDEDNET) && !defined(DEADLOCK)
#define FULL
#endif


#ifdef HASHSIZE

#if HASHSIZE < 1
#undef HASHSIZE
#define HASHSIZE 1
#endif

#if (HASHSIZE > 2) && (HASHSIZE < 4)
#undef HASHSIZE
#define HASHSIZE 2
#endif

#if (HASHSIZE > 4) && (HASHSIZE < 8)
#undef HASHSIZE
#define HASHSIZE 4
#endif

#if (HASHSIZE > 8) && (HASHSIZE < 16)
#undef HASHSIZE
#define HASHSIZE 8
#endif

#if (HASHSIZE > 16) && (HASHSIZE < 32)
#undef HASHSIZE
#define HASHSIZE 16
#endif

#if (HASHSIZE > 32) && (HASHSIZE < 64)
#undef HASHSIZE
#define HASHSIZE 32
#endif

#if (HASHSIZE > 64) && (HASHSIZE < 128)
#undef HASHSIZE
#define HASHSIZE 64
#endif

#if (HASHSIZE > 128) && (HASHSIZE < 256)
#undef HASHSIZE
#define HASHSIZE 128
#endif

#if (HASHSIZE > 256) && (HASHSIZE < 512)
#undef HASHSIZE
#define HASHSIZE 256
#endif

#if (HASHSIZE > 512) && (HASHSIZE < 1024)
#undef HASHSIZE
#define HASHSIZE 512
#endif

#if (HASHSIZE > 1024) && (HASHSIZE < 2048)
#undef HASHSIZE
#define HASHSIZE 1024
#endif

#if (HASHSIZE > 2048) && (HASHSIZE < 4096)
#undef HASHSIZE
#define HASHSIZE 2048
#endif

#if (HASHSIZE > 4096) && (HASHSIZE < 8192)
#undef HASHSIZE
#define HASHSIZE 4096
#endif

#if (HASHSIZE > 8192) && (HASHSIZE < 16384)
#undef HASHSIZE
#define HASHSIZE 8192
#endif

#if (HASHSIZE > 16384) && (HASHSIZE < 32768)
#undef HASHSIZE
#define HASHSIZE 16384
#endif

#if (HASHSIZE > 32768) && (HASHSIZE < 65536)
#undef HASHSIZE
#define HASHSIZE 32768
#endif

#if (HASHSIZE > 65536) && (HASHSIZE < 131072)
#undef HASHSIZE
#define HASHSIZE 65536
#endif

#if (HASHSIZE > 131072) && (HASHSIZE < 262144)
#undef HASHSIZE
#define HASHSIZE 131072
#endif

#if (HASHSIZE > 262144) && (HASHSIZE < 524288)
#undef HASHSIZE
#define HASHSIZE 262144
#endif

#if (HASHSIZE > 524288) && (HASHSIZE < 1048576)
#undef HASHSIZE
#define HASHSIZE 524288
#endif

#if (HASHSIZE > 1048576) && (HASHSIZE < 2097152)
#undef HASHSIZE
#define HASHSIZE 1048576
#endif

#if (HASHSIZE > 2097152) && (HASHSIZE < 4194304)
#undef HASHSIZE
#define HASHSIZE 2097152
#endif

#if (HASHSIZE > 4194304) && (HASHSIZE < 8388608)
#undef HASHSIZE
#define HASHSIZE 4194304
#endif

#if (HASHSIZE > 8388608) && (HASHSIZE < 16777216)
#undef HASHSIZE
#define HASHSIZE 8388608
#endif

#if (HASHSIZE > 16777216) && (HASHSIZE < 33554432)
#undef HASHSIZE
#define HASHSIZE 16777216
#endif

#if (HASHSIZE > 33554432) && (HASHSIZE < 67108864)
#undef HASHSIZE
#define HASHSIZE 33554432
#endif

#if (HASHSIZE > 67108864) && (HASHSIZE < 134217728)
#undef HASHSIZE
#define HASHSIZE 67108864
#endif

#if (HASHSIZE > 134217728) && (HASHSIZE < 268435456)
#undef HASHSIZE
#define HASHSIZE 134217728
#endif

#if (HASHSIZE > 268435456) && (HASHSIZE < 536870912)
#undef HASHSIZE
#define HASHSIZE 268435456
#endif

#if (HASHSIZE > 536870912) && (HASHSIZE < 1073741824)
#undef HASHSIZE
#define HASHSIZE 536870912
#endif

#if (HASHSIZE > 1073741824) && (HASHSIZE < 2147483648)
#undef HASHSIZE
#define HASHSIZE 1073741824
#endif

#if (HASHSIZE > 2147483648)
#undef HASHSIZE
#define HASHSIZE  2147483648
#endif



#endif

#ifndef HASHSIZE
#define HASHSIZE 65536;
#endif

#ifndef SYMMINTEGRATION
#define SYMMINTEGRATION 3
#endif

#if SYMMINTEGRATION > 8
#undef SYMMINTEGRATION
#define SYMMINTEGRATION 3
#endif

#if SYMMINTEGRATION == 1
#define SYMMPROC symm_search_marking
#elif SYMMINTEGRATION == 2
#define SYMMPROC symm_search_marking2
#elif SYMMINTEGRATION == 3
#define SYMMPROC canonical_representitive
#elif SYMMINTEGRATION == 6
#define SYMMPROC TJ_pr_canonical_representative
#elif SYMMINTEGRATION == 7
#define SYMMPROC TJ_pr_canonical_representative
#elif SYMMINTEGRATION == 8
#define SYMMPROC TJ_nauty_canonical_representative
#else 
#define SYMMPROC canonical_representitive_on_the_fly
#endif

#ifdef APPROXIMATE_CANONIZATION
#undef APPROXIMATE_CANONIZATION
#endif

#if SYMMINTEGRATION == 4
#define APPROXIMATE_CANONIZATION
#endif


#ifdef BOUNDEDPLACE
#define COVER
#endif

#ifdef BOUNDEDNET
#define COVER
#endif

#ifdef COVER
#undef CAPACITY
#undef REVERSIBILITY
#undef REACHABILITY
#undef MODELCHECKING
#undef DEADLOCK
#undef HOME
#undef FINDPATH
#undef STATEPREDICATE
#ifdef FULL
#define BOUNDEDNET
#endif
#undef FULL
#if !defined(BOUNDEDPLACE) && !defined(DEADTRANSITION) && !defined(BOUNDEDNET)
#define BOUNDEDNET
#endif
#undef GRAPH
#define GRAPH depth_first
#endif

#ifdef FINDPATH
#undef REACHABILITY
#undef STATEPREDICATE
#undef MODELCHECKING
#undef BOUNDEDPLACE 
#undef DEADTRANSITION
#undef DEADLOACK
#undef REVERSIBILITY
#undef HOME
#undef BOUNDEDNET
#undef FULL
#define WITHFORMULA
#undef SYMMETRY
#undef COVER
#define FIRELIST firelist
#endif

/////////////////////////////////////////////////////////////////////////

#ifdef HOME
#undef COVER
#undef FULL
#undef REACHABILITY
#undef BOUNDEDPLACE
#undef BOUNDEDNET
#undef DEADTRANSITION
#undef STATEPREDICATE
#undef DEADLOCK
#undef REVERSIBILITY
#undef FINDPATH
#undef SYMMETRY
#undef MODELCHECKING
#ifndef STUBBORN
#define STUBBORN
#endif
#define FIRELIST tsccstubbornlist
#define EXTENDED
#define TSCC
#undef GRAPH
#define GRAPH depth_first
#endif

#ifdef REVERSIBILITY
#undef HOME
#undef REACHABILITY
#undef BOUNDEDPLACE
#undef BOPUNDEDNET
#undef DEADTRANSITION
#undef DEADLOCK
#undef STATEPREDICATE
#undef FINDPATH
#undef FULL
#ifndef STUBBORN
#define STUBBORN
#endif
#define EXTENDED
#define TSCC
#define FIRELIST tsccstubbornlist
#undef GRAPH
#define GRAPH depth_first
#endif

#ifdef DEADTRANSITION
#undef HOME
#undef REACHABILITY
#undef MODELCHECKING
#undef BOUNDEDNET
#undef DEADLOCK
#undef REVERSIBILITY
#undef STATEPREDICATE
#undef FINDPATH
#undef FULL
#undef BOUNDEDNET
#ifdef STUBBORN
#define FIRELIST stubbornfireliststatic
#else
#define FIRELIST firelist
#endif
#endif

#ifdef BOUNDEDPLACE
#undef HOME
#undef REACHABILITY
#undef MODELCHECKING
#undef DEADTRANSITION
#undef DEADLOCK
#undef REVERSIBILITY
#undef FINDPATH
#undef STATEPREDICATE
#undef FULL
#undef BOUNDEDNET
#ifdef STUBBORN
#define FIRELIST stubbornfireliststatic
#else
#define FIRELIST firelist
#endif
#endif


#ifdef BOUNDEDNET
#undef REACHABILITY
#undef MODELCHECKING
#undef BOUNDEDPLACE
#undef DEADTRANSITION
#undef DEADLOCK
#undef REVERSIBILITY
#undef STATEPREDICATE
#undef HOME
#undef FINDPATH
#undef FULL
#ifdef STUBBORN
#define FIRELIST stubbornfireliststatic
#else
#define FIRELIST firelist
#endif
#endif

#ifdef REACHABILITY
#undef MODELCHECKING
#undef BOUNDEDPLACE
#undef BOUNDEDNET
#undef DEADTRANSITION
#undef DEADLOCK
#undef REVERSIBILITY
#undef STATEPREDICATE
#undef HOME
#undef FINDPATH
#undef FULL
#ifdef STUBBORN
#define FIRELIST stubbornfirelistreach
#else
#define FIRELIST firelist
#endif
#endif

#ifdef MODELCHECKING
#undef REACHABILITY
#undef BOUNDEDPLACE
#undef BOUNDEDNET
#undef DEADTRANSITION
#undef DEADLOCK
#undef REVERSIBILITY
#undef STATEPREDICATE
#undef HOME
#undef FINDPATH
#undef FULL
#define FIRELIST firelist
#define WITHFORMULA
#ifdef STUBBORN
#define EXTENDED
#endif
#endif

#ifdef DEADLOCK
#undef REACHABILITY
#undef BOUNDEDPLACE
#undef BOUNDEDNET
#undef DEADTRANSITION
#undef REVERSIBILITY
#undef HOME
#undef STATEPREDICATE
#undef FINDPATH
#undef FULL
#undef MODELCHECKING
#undef COVER
#ifdef STUBBORN
#define FIRELIST tsccstubbornlist
#else
#define FIRELIST firelist
#endif
#endif

#ifdef STATEPREDICATE
#define WITHFORMULA
#undef REACHABILITY
#undef BOUNDEDPLACE
#undef BOUNDEDNET
#undef DEADTRANSITION
#undef REVERSIBILITY
#undef HOME
#undef DEADLOCK
#undef FINDPATH
#undef FULL
#undef MODELCHECKING
#undef COVER
#ifdef STUBBORN
#ifdef RELAXED
#ifndef EXTENDED
#define EXTENDED
#endif
#define FIRELIST relaxedstubbornset
#else
#define FIRELIST stubbornfirelistpredicate
#endif
#else
#define FIRELIST firelist
#endif
#endif


#ifdef FULL
#ifdef STUBBORN
#define FIRELIST tsccstubbornlist
#else
#define FIRELIST firelist
#endif
#endif

/// Create dimensions for storing markings
// MSIZE = Number of bits for the marking of a place
// MPERWORD = places packed into an unsigned int
// MASK = 2^MSIZE -1

#ifdef CAPACITY

#if CAPACITY < 2
#define MSIZE 1
#define MPERWORD 32
#define MASK 1
#endif

#if (CAPACITY > 1) && (CAPACITY < 4)
#define MSIZE 2
#define MPERWORD 16
#define MASK 3
#endif

#if (CAPACITY > 3) && (CAPACITY < 8)
#define MSIZE 3
#define MPERWORD 10
#define MASK 7
#endif

#if (CAPACITY > 7) && (CAPACITY < 16)
#define MSIZE 4
#define MPERWORD 8
#define MASK 15
#endif

#if (CAPACITY > 15) && (CAPACITY < 32)
#define MSIZE 5
#define MPERWORD 6
#define MASK 31
#endif

#if (CAPACITY > 31) && (CAPACITY < 64)
#define MSIZE 6
#define MPERWORD 5
#define MASK 63
#endif

#if (CAPACITY > 63) && (CAPACITY < 256)
#define MSIZE 7
#define MPERWORD 4
#define MASK 255
#endif

#if (CAPACITY > 255) && (CAPACITY < 1024)
#define MSIZE 10
#define MPERWORD 3
#define MASK 1023
#endif

#if (CAPACITY > 1023) && (CAPACITY < 65536)
#define MSIZE 16
#define MPERWORD 2
#define MASK 65535
#endif

#if (CAPACITY > 65535)
#undef CAPACITY
#define MSIZE 32
#define MPERWORD 1
#define MASK UINT_MAX
#endif

#else
#define MSIZE 32
#define MPERWORD 1
#define MASK UINT_MAX
#endif
/////////////////////////////

#ifndef MODELCHECKING
#undef EXTENDEDCTL
#endif
#endif

#ifndef MAXATTEMPT 
#define MAXATTEMPT 0
#endif











